// NoSeeVar - by BuzzKill <buzzkill@100acrebloodbath.com>

// cfg read code ripped from Botman's stripper2. Thx B!

#include <stdio.h>
#include <string.h>

#ifdef WIN32
	#include <io.h>
#else
	#include <unistd.h>
#endif

#include "extdll.h"
#include "meta_api.h"
#include "nsv_mm.h"

char* blocked_cvars [] =
{
	{"gamedir"},
	{"visiblemaxplayers"},
	{"protocol"},
	{"mod_url_info"},
	{"mod_url_dl"},
	{"mod_version"},
	{"mod_size"},
	{"mod_svonly"},
	{"mod_cldll"},
	{"secure"},
	{"botcount"},
	{ NULL },

};

char cvar_list[256];


bool process_cfg( void )
{
	char game_dir[256];
	char filename[256];
	FILE* fp = NULL;

	// find the directory name of the currently running MOD...
	(* g_engfuncs.pfnGetGameDir)(game_dir);
	strcpy(filename, game_dir);

#ifndef WIN32
	strcat(filename, "/");
#else
	strcat(filename, "\\");
#endif

	strcat(filename, "nsv.cfg");

	if ((fp = fopen(filename, "r")) == NULL)
	{
		//LOG_CONSOLE(PLID, "[CVS] ERROR: Could not open \"cvs.cfg\" file!");
		LOG_MESSAGE(PLID, "ERROR: Could not open \"nsv.cfg\" file!");
		return TRUE; // return bad status
	}

	char input[1024];
	char cvar[1024];
	
	int flag;

	strcpy(cvar_list,"");

	int len, pos;

	while (!feof(fp))
	{
		if (fgets(input, 1023, fp) != NULL)
		{
			len = strlen(input);

			if (input[len - 1] == '\n')
				input[len - 1] = 0;
		}
		else
			input[0] = 0;

		pos = 0;

		while (isspace(input[pos]))
			pos++;    // skip leading blanks

		if ((input[pos] == '/') && (input[pos + 1] == '/'))
			continue; // skip comment lines

		if (input[pos] == 0)
			continue; // skip empty lines

		int ass = sscanf(input, "%s %d", cvar, &flag);
		int noblock = 0;

		if (flag > 1 || flag > 1024 || ass == 1)
			flag = 8;

		for(int i = 0; blocked_cvars[i]; i++)
		{
			if (strcasecmp(blocked_cvars[i],cvar) == 0)
			{
				LOG_MESSAGE(PLID, "cvar %s cannot be hidden.", cvar);
				noblock = 1;
				break;
			}
		}

		if (noblock == 0)
		{
			
			
			cvar_t* cvs_generic = CVAR_GET_POINTER( cvar );
			if (cvs_generic != NULL) // already exists - reclass it
			{
				cvs_generic->flags = flag;
				LOG_MESSAGE(PLID, "Reclassed/hid cvar %s (flag= %d)", cvar,flag);
			} else { // register it
				cvar_t cvs_generic = {cvar,"", flag, 0, NULL};
				CVAR_REGISTER(&cvs_generic);
				LOG_MESSAGE(PLID, "Registered/hid cvar %s (flag= %d)", cvar,flag);
			}

			if (nsv_build_list->value > 0)
			{

				if (strlen(cvar_list) + strlen(cvar) < 250)
				{
					strcat(cvar_list,cvar);
					strcat(cvar_list," ");
				}
			}
		}
	}



	fclose(fp);
	return FALSE;
}
